require 'hakuban'
require_relative './cpu-usage.rb'


id = "#{$$}@#{`hostname`.strip}"

hakuban = Hakuban::LocalNode.new
connector = Hakuban::WebsocketConnector.new(hakuban, "ws://localhost:3001")
all_utilizations = hakuban.tag("utilizations").observe
my_utilization = hakuban.object(["utilizations"],{id: id}).expose

previous_cpu_usage_state = nil

loop {
	previous_cpu_usage_state, cpu_usage = CPU::current_usage(previous_cpu_usage_state)
	my_utilization.set_object_state([Time.new.to_f],{ "percentage"=>cpu_usage })    if cpu_usage

	all_utilizations.object_descriptors.map { |descriptor|
		if data = all_utilizations.object_state(descriptor).data
			puts "#{descriptor.json["id"]} -> #{data["percentage"]}"
		end
	}

	sleep 1
	puts
}
